//+------------------------------------------------------------------+
//|                                               Ind-Fractals-1.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 8 
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 Purple
#property indicator_color4 Purple
#property indicator_color5 Aqua
#property indicator_color6 Aqua
#property indicator_color7 Yellow
#property indicator_color8 Yellow
//---- input parameters
//extern bool      Comm=false;
extern bool AlertM5TimeFrame=true;
extern bool AlertM15TimeFrame=true;
extern bool AlertH1TimeFrame=true;
extern bool AlertH4TimeFrame=true;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

//M5
   SetIndexStyle(0,DRAW_ARROW); 
   SetIndexArrow(0,234);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
  
   
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,233);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   
   
   
//M15   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,234);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
  
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,233);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   
   
//H1   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,234);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,233);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
   
   
 //H4  
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,234);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexEmptyValue(6,0.0);
   
   
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,233);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexEmptyValue(7,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//------------------------------------------------------------------  
bool Fractal (string F,int Per, int shift)
  {
   if (Period()>Per) return(-1);
   Per=Per/Period()*2+MathCeil(Per/Period()/2);
   if (shift<Per)return(-1);
   if (shift>Bars-Per)return(-1); 
   for (int i=1;i<=Per;i++)
     {
      if (F=="U")
        {
         if (High[shift+i]>High[shift])return(-1);
         if (High[shift-i]>=High[shift])return(-1);     
        }
      if (F=="L")
        {
         if (Low[shift+i]<Low[shift])return(-1);
         if (Low[shift-i]<=Low[shift])return(-1);
        }        
     }
   return(1);   
  }  
//------------------------------------------------------------------
int start()
  {
   int H4=240, H1=60, M15=15, M5=5,B;
   double P;
//   int    counted_bars=IndicatorCounted();
   B=Bars;
   if (Period()==H4)P=15*Point;
   if (Period()==H1)P=7*Point;
   if (Period()==M15)P=4*Point;
   if (Period()==30)P=3*Point;
   if (Period()==M5)P=2*Point;
   if (Period()==5)P=1*Point;
   if (Period()==1)P=0.5*Point;   
   for (int shift=1;shift<B;shift++)
      {
       if (Fractal("U",M5,shift)==1) 
         {
         ExtMapBuffer1[shift]=High[shift]+P;
         if(AlertM5TimeFrame==true && AlertFirstFoundFractal(Time[shift], "M5")==true) Alert("Upper Fractal on" + Symbol() + " M5 time frame");          
         }
       else ExtMapBuffer1[shift]=0;       
       
       
       if (Fractal("L",M5,shift)==1)
         {
         ExtMapBuffer2[shift]=Low[shift]-P;
         if(AlertM5TimeFrame==true && AlertFirstFoundFractal(Time[shift], "M5")==true) Alert("Lower Fractal on" + Symbol() + " M5 time frame");                   
         }
       else ExtMapBuffer2[shift]=0;
       
       
       
       if (Fractal("U",M15,shift)==1)
         {
         ExtMapBuffer3[shift]=High[shift]+P;
         if(AlertM15TimeFrame==true && AlertFirstFoundFractal(Time[shift], "M15")==true) Alert("Upper Fractal on" + Symbol() + " M15 time frame");          
         }
       else ExtMapBuffer3[shift]=0;
       
       if (Fractal("L",M15,shift)==1)
         {
         ExtMapBuffer4[shift]=Low[shift]-P;
         if(AlertM15TimeFrame==true && AlertFirstFoundFractal(Time[shift], "M15")==true) Alert("Lower Fractal on" + Symbol() + " M15 time frame");
         }
       else ExtMapBuffer4[shift]=0;
       
       
       
       if (Fractal("U",H1,shift)==1)
         {
         ExtMapBuffer5[shift]=High[shift]+P;
         if(AlertH1TimeFrame==true && AlertFirstFoundFractal(Time[shift], "H1")==true) Alert("Upper Fractal on" + Symbol() + " H1 time frame");
         }
       else ExtMapBuffer5[shift]=0;
       
       if (Fractal("L",H1,shift)==1)
         {
         ExtMapBuffer6[shift]=Low[shift]-P;
         if(AlertH1TimeFrame==true && AlertFirstFoundFractal(Time[shift], "H1")==true) Alert("Lower Fractal on" + Symbol() + " H1 time frame");
         }
       else ExtMapBuffer6[shift]=0;
       
       
       
       if (Fractal("U",H4,shift)==1)
         {
         ExtMapBuffer7[shift]=High[shift]+P;
         if(AlertH4TimeFrame==true && AlertFirstFoundFractal(Time[shift], "H4")==true) Alert("Upper Fractal on" + Symbol() + " H4 time frame");
         }
       else ExtMapBuffer7[shift]=0;
       
       if (Fractal("L",H4,shift)==1)
         {
         ExtMapBuffer8[shift]=Low[shift]-P;       
         if(AlertH4TimeFrame==true && AlertFirstFoundFractal(Time[shift], "H4")==true) Alert("Lower Fractal on" + Symbol() + " H4 time frame");
         }
       else ExtMapBuffer8[shift]=0;
      }
  Comment("M5 - White\nM15 - Purple\nH1 - Aqua\nH4 - Yellow");
 //  ObjectCreate("T_H4",OBJ_TEXT,0,Time[30],Close[0]+10*P);
 //  ObjectSetText("T_H4","H4",10,"Times New Roman",indicator_color8);
 //  ObjectCreate("T_H1",OBJ_TEXT,0,Time[20],Close[0]+10*P);
 //  ObjectSetText("T_H1","H1",10,"Times New Roman",indicator_color6);
 //  ObjectCreate("T_M15",OBJ_TEXT,0,Time[10],Close[0]+10*P);
 //  ObjectSetText("T_M15","M15",10,"Times New Roman",indicator_color4);
 //  ObjectCreate("T_M5",OBJ_TEXT,0,Time[0],Close[0]+10*P);
 //  ObjectSetText("T_M5","M5",10,"Times New Roman",indicator_color2);
   return(0);
  }
//+------------------------------------------------------------------+


bool AlertFirstFoundFractal(datetime candleOpenTime, string chartTimeFrame)
{
   static datetime foundbarM5;
   static datetime foundbarM15;
   static datetime foundbarH1;
   static datetime foundbarH4;   
   
   if(chartTimeFrame=="M5" && candleOpenTime!=foundbarM5 && candleOpenTime>foundbarM5)
        { 
         foundbarM5=candleOpenTime;
         return (true);
        } 
     
        
   
   else if(chartTimeFrame=="M15" && candleOpenTime!=foundbarM15 && candleOpenTime>foundbarM15)
        { 
         foundbarM15=candleOpenTime;
         return (true);
        }  
        
    
    
   else if(chartTimeFrame=="H1" && candleOpenTime!=foundbarH1 && candleOpenTime>foundbarH1)
        { 
         foundbarH1=candleOpenTime;
         return (true);
        } 
 
     
   else if(chartTimeFrame=="H4" && candleOpenTime!=foundbarH4 && candleOpenTime>foundbarH4)
        { 
         foundbarH4=candleOpenTime;
         return (true);
        } 
        
  else 
        {
         return(false);
        }   
}